      DOUBLE PRECISION XN,YN,DYN,XK,EPS,THRESH,H,HMIN,HMAX,Y,RAB,Q,YT,
     1                 DY,DYT  
      PARAMETER (K=18,K2=25)
      DIMENSION RAB(2*K*K+5*K+7*K+K2*K2+8*K2+6*K2+24+5),
     1          EPS(2),IU(2),THRESH(2),MEXACT(2),NUMBES(2)
      EXTERNAL F,F2TREA
      COMMON/STAT76/NACCEP,NREJEC
      COMMON/BLOCK/N,Q
      DATA IU/2,2/, EPS/2*0.5D-12/, THRESH/2*1.D0/, MEXACT/1,1/,
     1     NUMBES/1,1/ 
      M=1
      Q=4.0D0
      XN=0.
      YN=EXP(Q)
      DYN=Q*YN
C
      XK=7.D0
      YT =EXP(Q*(XK+1.D0))
      DYT=Q*YT
C
      K0=K
      INIAPR=1
      IMAX=28
      MESTER=1
      H=1.D0
      HMIN=1.D-3
      HMAX=XK
      K20=K2
      IMAX2=3
      NATTEM=3
      N=0  
      CALL DE65D(F,F2TREA,M,XN,YN,DYN,XK,K0,INIAPR,IMAX,IU,EPS,THRESH,
     1           MEXACT,M,MESTER,H,HMIN,HMAX,K20,IMAX2,NATTEM,Y,DY,RAB,
     2           IERR)  
      PRINT 50,IERR
      PRINT 49,N
      PRINT 52,NACCEP,NREJEC
      PRINT 51,Y,YT,(YT-Y)/Y
      PRINT 53,DY,DYT,(DYT-DY)/DY
      STOP
C
   49 FORMAT(1X,'N=',I12)
   50 FORMAT(1X,'IERR=',I2)
   51 FORMAT(1X,'Y =',D25.16/1X,'YT=',D25.16/1X,'(YT-Y)/Y=',D25.16)
   52 FORMAT(1X, 'NACCEP=',I4,5X,'NREJEC=',I4)
   53 FORMAT(1X,'DY =',D25.16/1X,'DYT=',D25.16/1X,'(DYT-DY)/DY=',D25.16)
      END
C
      SUBROUTINE F(X,Y,DY,Z,M)
      DOUBLE PRECISION X,Y,DY,Z,Q
      COMMON/BLOCK/N,Q
      Z=Q*DY
      N=N+1
      RETURN
      END

      SUBROUTINE F2TREA(S,XI,XE,Y,DY,AY,ADY,AD2Y,M,KP1,KP2,KP3)
      INTEGER S,M,KP1,KP2,KP3
      DOUBLE PRECISION XI,XE,Y,DY,AY,ADY,AD2Y,YT,DYT,MIDPNT,ALPN,SOL,
     1                 SOLT,DER,DERT,BK(2),Q
      DIMENSION AY(M,KP3),ADY(M,KP2),AD2Y(M,KP1)
C
      PRINT 110,S,XI,XE
      Q=4.D0
      YT =EXP(Q*(XE+1.D0))
      PRINT 30,Y,YT,(YT-Y)/Y
C
      DYT=Q*YT
      PRINT 33,DY,DYT,(DYT-DY)/DY
C---------------------------------------------------
      MIDPNT=0.5D0*(XI+XE)
C
C   Transformation of point MIDPNT into a point ALPN of segment [-1, 1]
C
      ALPN=2.D0*(MIDPNT-XI)/(XE-XI)-1.D0      
C  
C   Calculation of partial sum SOL of KP2 order with Chebyshev coefficients AY
C        at point ALPN  (BK - working array  of dimension M*2)
C
      CALL DE70DC(M,KP2,ALPN,AY,SOL,BK)
      SOLT=EXP(Q*(MIDPNT+1.D0))
      PRINT 29,MIDPNT
      PRINT 31,SOL,SOLT,(SOLT-SOL)/SOL
C
C-------------------------------------------------
C   Calculation of partial sum DER of KP1 order with Chebyshev coefficients ADY
C        at point ALPN  (BK - working array  of dimension M*2)
C
      CALL DE70DC(M,KP1,ALPN,ADY,DER,BK)
      DERT=Q*SOLT
      PRINT 32,DER,DERT,(DERT-DER)/DER
C
C_______________________________________________
C
C
      DO 10 L=1,M
      PRINT 150,L
      PRINT 85,(J-1,AY(L,J  ),ADY(L,J  ),AD2Y(L,J),J=1,KP1)
      PRINT 86, KP1,AY(L,KP2),ADY(L,KP2),
     1          KP2,AY(L,KP3)
   10 CONTINUE
C
      PRINT 48
      RETURN
C
   29 FORMAT(/64(1H-), /1X,'MIDPNT=',D25.16)
   30 FORMAT(1X,'Solution Y and YT at the end  of the segment [XI,XE],',
     1       'i.e. Y(XE), YT(XE):' ,
     2        /1X,'Y =',D25.16/1X,'YT=',D25.16/1X,'(YT-Y)/Y=',D25.16)
C
   31 FORMAT(/1X,'Solution SOL and SOLT at the midpoint 0.5*(XI+XE) of',
     1        ' segment [XI, XE]: ',
     2        /1X,'SOL  =',D25.16/1X,'SOLT =',D25.16,
     3        /1X,'(SOLT-SOL)/SOL=',D25.16)
C
   32 FORMAT(/1X,'Derivative DER and DERT at the midpoint 0.5*(XI+XE)',
     1        'of segment [XI, XE]: ',
     2        /1X,'DER  =',D25.16/1X,'DERT =',D25.16,
     3        /1X,'(DERT-DER)/DER=',D25.16)
C
   33 FORMAT(/1X,'Derivative DY and DYT at the end  of the segment',
     1       ' [XI,XE], i.e. DY(XE), DYT(XE):' 
     2        /1X,'DY =',D25.16/1X,'DYT=',D25.16/1X,'(DYT-DY)/DY=',
     3         D25.16)
C
   48 FORMAT(/1X,64(1H*)/) 
   85 FORMAT(5X,I2,4X,3D23.16)
   86 FORMAT(5X,I2,4X,2D23.16)
  110 FORMAT(/1X,'Coefficients AY, ADY and AD2Y on ',I3,'  segment:  '/
     1        1X,'XI=',D25.16,5X,'XE=',D25.16/)
C      
  150 FORMAT(//'   Number of',15X,'Chebyshev coefficients'
     *       ' for ',I1,' component'/  
     1        14X,66(1H-)/
     2       ' coefficient',9X,'for Y',18X,'for Y''',18X,'for Y'''''/         
     3        1X,79(1H-)/)
C   
      END